stages:
  - build-cache
  - lint
  - unit-test
  - build

build-cache:
  stage: build-cache
  image: mhart/alpine-node:12
  script:
    - npm ci --no-audit
  artifacts:
    paths:
      - node_modules
    name: ${CI_JOB_ID}
    expire_in: 1 hour
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - node_modules/

node:
  stage: lint
  dependencies:
    - build-cache
  image: mhart/alpine-node:12
  script:
    - npm run lint

unit_test:
  stage: unit-test
  dependencies:
    - build-cache
  image: mhart/alpine-node:12
  script:
    - npm test

create_container:
  stage: build
  image: docker:18.09
  services:
    - name: docker:18.09-dind
      alias: dockerhost
  variables:
    DOCKER_HOST: tcp://dockerhost:2375
    DOCKER_DRIVER: overlay2    
  before_script:
    - echo "$PASSWORD" | docker login -u $USERNAME --password-stdin
  script:
    - docker build -t $IMAGE_NAME:${CI_COMMIT_SHA:0:8} .
    - docker push $IMAGE_NAME
  after_script:
    - docker logout
